//
//	Rand.swift
//	Plug
//
//	Created by Alex Marchant on 10/11/14.
//	Copyright (c) 2014 Plug. All rights reserved.
//

import Foundation

struct Rand {
	static func inRange(_ range: Range<Int>) -> Int {
		// arc4random_uniform(_: UInt32) returns UInt32, so it needs explicit type conversion to Int
		// note that the random number is unsigned so we don't have to worry that the modulo
		// operation can have a negative output
		return Int(arc4random_uniform(UInt32(range.upperBound + 1 - range.lowerBound))) + range.lowerBound
	}
}
